;*** NOTE: don't mess with zp-values, make sure $D800-$D827=14, make sure $D023=$X2, make sure y=0 ***
;***set tabs to 9 spaces***
;
;
;
; +-------------------------------------------------------------+
; |    "Kefrens Without For" by CyberBrain/NoName 01/03/2004.   !
; !                                                             :
; : the source 4 da second n' best 256b kefrensbars on the C64! |
;       -  -- --- ----------------------------------------------+
;
;              assemble with ca65. (www.cc65.org)
;
;                      lame code rulez!
;
;
; 


	

	.debuginfo +
	.feature labels_without_colons 	;<- man behver ikke bruge kolon i efter labels (labels skal starte p 1st char)
	.feature pc_assignment	    	;<- man kan skrive *=xxxx istedetfor .org xxxx 
	*=$0801
	.word *
	*=$0801

xx	= $ff
xxxx	= $ffff

sincnt1	= $05
sincnt2	= $06
tmp1	= $13	;=$00 (set by sinus-basic-code)	***NDRES HVIS BASIC-CODEN NDRES*** (vrdien af den her byte skal vre lig vrdien af tmp3! - pga. codegenerator)
tmp2	= $14	;=$2D (set by sinus-basic-code)	***NDRES HVIS BASIC-CODEN NDRES***
tmp3	= $44    ;=$00 (set by sinus-basic-code)	***NDRES HVIS BASIC-CODEN NDRES*** (vrdien af den her byte skal vre lig vrdien af tmp1! - pga. codegenerator)
tmp4	= $45    ;=$54 (set by sinus-basic-code)	***NDRES HVIS BASIC-CODEN NDRES***
dummy	= $07

igenigenAdr = $2d00	; = hvor igenigen-coden skal smides hen
igenigen2Adr= $5400

sinus 	= $1000
cntLo	= $1100		;counts: 0,0,1,1,2,2,3,3,0,0,1,1,2,2,3,3,...
cntHi	= $0400		;counts: 1,2,3,4,5,6,...,254,255
doubleSin= $1300		;(lo-byte of doubleSin MUST be $00!! - p.g.a. calcDoubleSinus og igenigenCode)


charset	= $2000
kefScr	= charset+7+6*8	; = "screen to plot" = "the first byte in the char to be plotted to (kun hver 8. byte efter denne byte bli'r plottet i)"

kefLines = 193+1		; = hvor mange pixels hj kefren-baren skal vre. (hvor mange gange igenigen coden gr igen) (SKAL ende med en $D011=%00011011 sta!)


D011init = %00011011

;col1	= 6+8	(assuming that $d800 is 14 when starting)
col2	= 3
col3	= 14

basic	; inform user how many basic bytes that are free, when entering the secret park
	.byte $2c ,$08 ,$00 ,$00  ,$81 ,$54 ,$b2 ,$30  ,$a4 ,$32 ,$35 ,$36  ,$3a ,$97 ,$34 ,$30	
	.byte $39 ,$36 ,$aa ,$54  ,$2c ,$bf ,$28 ,$54  ,$ad ,$32 ,$30 ,$2e, $34, $29  ,$ac ,$35 ,$30 ,$aa; T/20.4 og T/41=100% smooth
	.byte $35 ,$30 ,$3a ,$82  ,$3a ,$9e ,$32 ,$30  ,$39 ,$31+2


.macro initTables
.proc	;
	ldx #0
loop	;Convert sinus/2 -> sinlo, sinhi
	.byte $9c, <(charset+$100), >(charset+$100) ; (**y must be 0 here!**) "SHY (charset+$100),x" = store y and hi-byte of (charset+$100) into (charset+$100)+x (because: 1) basic makes it crash if nothing is here, 2) some c64's has $FF's in these bytes, so since y=0 this will change them to $00)
	txa
	sta $0400,x ;$0400=sinHi
	.byte $6b,%00000110 ;ARR #%00000110   	;and #%00000110, lsr
	sta cntLo,x

	dex
	bne loop	
.endproc

.proc	;Generate igenigen-code

;	lda #<igenigenAdr
;	sta <tmp1
;	lda #>igenigenAdr
;	sta <tmp2
;	lda #<igenigen2Adr
;	sta <tmp3
;	lda #>igenigen2Adr
;	sta <tmp4
	
	ldx #kefLines
loop1	ldy #igenigenLen+1		;"+1" da RTS osse skal med
loop2	lda igenigenCode,y
	sta (tmp1),y
	lda igenigen2Code,y
	sta (tmp3),y
	dey
	bpl loop2
	
	ldy igenSto			; ndr $D011 vrdi
	iny
	tya
	and #%00000111
	;ora #%00011000
	sta igenSto
	
	inc igenSto2
	inc igen2Sto
	
		
	lda <tmp1
	clc
	adc #igenigenLen
	sta <tmp1
	sta <tmp3
	bcc *+6
	inc <tmp2
	inc <tmp4
	
	dex
	bne loop1
	
	stx $d020
	stx $d021
	stx igenigen2Adr + (kefLines-1) * igenigenLen + igenigen2bcc + 1	; gr s den sidste BCC hopper 0 bytes frem. (dvs. til rts'en)
.endproc
.endmacro


.macro	kefren
.proc	;kalder rutinen
	jsr igenigenAdr
	
	;clear kefrenchars
	.byte $ab,0 ;LAX #0  = lda #0, tax (or: ora #?, and #0, tax  on some C64's)
loop	sta charset,x
	inx
	bne loop
.endproc
.endmacro

.macro setupVic
	lda #%00011000
	sta $d018
	sta $d016
	lda #col3
	sta $d022
	;lda #col2
	;sta $d023
	inc $d023		;<- **antager $d023=$F2!**
.endmacro

.macro calcDoubleSinus
.proc
	;calc doublesinus-table
	ldx <sincnt1
	ldy <sincnt2
	jsr igenigen2Adr

	;increase counters
	inc <sincnt1
	inc <sincnt1
	dec <sincnt2
.endproc
.endmacro


;---------------------------------------
;*****************CODE******************
;---------------------------------------
	
	
	sei
	initTables
	setupVic

.proc

loop	calcDoubleSinus

	;lda $d011
	;bmi *-3

	lda #$30+%011-1
	cmp $d012
	bne *-3
	
	
	dec $d011
	;bit xx
	
	ldx #87+1
	dex
	bne *-1	;delay=2+(5*x)-1 <=> x=(delay-1)/5

	kefren
	
	beq loop;jmp loop ;**antager at z=1 her!**

.endproc

;---------------------------------------
;****************TABLES*****************
;---------------------------------------

kefORA1	;grafikken for de 4 positioner i et char som den venstre del af kefren-baren kan vre i
	.byte %11011001
	.byte %00110110
	.byte %00001101
	.byte %00000011
	
kefAND1	;det der skal and'es vk af baggrunden for de 4 positioner i et char som den venstre del af kefren-baren kan vre i
	.byte %00000000
	.byte %11000000
	.byte %11110000
	.byte %11111100

kefORA2	;grafikken for de 4 positioner i et char som den hjre del af kefren-baren kan vre i
	.byte %11000000
	.byte %01110000
	.byte %10011100
	.byte %01100111

kefAND2	;det der skal and'es vk af baggrunden for de 4 positioner i et char som den hjre del af kefren-baren kan vre i
	.byte %00111111
	.byte %00001111
	.byte %00000011
	.byte %00000000
	
;---------------------------------------

; igenigencoden der tegner kefrens-barene, og inc'er $d011 sdan at charline 7 gentages
igenigenCode

igenSto = *+1	
	lda #D011init
	ora #%00011000
	sta $d011
	
igenSto2 = *+1
	ldy doubleSin		;lo-byte of doubleSin MUST be $00!! (lo-byte: 0,1,2,...,255)
	lda cntHi,y
	and #%11111000
	ldx cntLo,y
 	tay
	
	lda kefScr,y
	and kefAND1,x
	ora kefORA1,x
	sta kefScr,y
	
	lda kefScr+8,y
	and kefAND2,x
	ora kefORA2,x
	sta kefScr+8,y
	
	inc <dummy		;ZP
	
igenigenLen = * - igenigenCode
	rts			;<- kun brugt for sidste igenigen-del
;---------------------------------------

;igenigen coden der udregner lgger 2 sinus'er sammen -> doubleSin
igenigen2Code
	dex
	;dex
	iny
	iny
	;iny
	lda sinus,y
	adc sinus,x		;M IKKE OVERFLOWE!! (p.g.a. bcc'en)
igen2Sto = *+1
	sta doubleSin		;lo-byte of doubleSin MUST be $00!!

igenigen2bcc = * - igenigen2Code
	.byte $90 ;BCC
	.byte igenigenLen - igenigen2Len

igenigen2Len = * - igenigen2Code
	rts			;<- kun brugt for sidste igenigen-del
;---------------------------------------
